#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/asl.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

static void clean_exit(CONST_STRPTR s);

static struct ScreenModeRequester *screenreq;

int main(void)
{
    screenreq = (struct ScreenModeRequester *)AllocAslRequestTags(ASL_ScreenModeRequest,
        ASLSM_TitleText, "Select a screenmode",
        ASLSM_DoDepth,   TRUE,
        TAG_END);
    if ( ! screenreq) clean_exit("Can't open screenmoderequester\n");
    
    if (AslRequest(screenreq, NULL))
    {
    }
    else
    {
        clean_exit("Screenmoderequester cancelled\n");
    }

    printf("width %d height %d depth %d ID %x\n",
        screenreq->sm_DisplayWidth,
        screenreq->sm_DisplayHeight,
        screenreq->sm_DisplayDepth,
        screenreq->sm_DisplayID);

    clean_exit(NULL);
    return 0;
}

static void clean_exit(CONST_STRPTR s)
{
    if (s) PutStr(s);

    if (screenreq) FreeAslRequest(screenreq);
    
    exit(0);
}
